"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = deferUntil;

var _observable = require("rxjs/observable");

var _operators = require("rxjs/operators");

function deferUntil(fx) {
    return function (source$) {
        return new _observable.Observable.create(function (observer) {
            return source$.subscribe({
                next: function next(x) {
                    fx(x).pipe((0, _operators.ignoreElements)()).subscribe(function (y) {
                        return observer.next(y);
                    });
                },
                error: function error(err) {
                    observer.error(err);
                },
                complete: function complete() {
                    observer.complete();
                }
            });
        });
    };
}
module.exports = exports["default"];