import { Observable } from "rxjs/observable";
import { ignoreElements, concat, mergeMap, take } from "rxjs/operators";

export default function deferUntil(fx) {
    return function (source$) {
        return new Observable.create(function (observer) {
            return source$.subscribe({
                next: function next(x) {
                    fx(x).pipe(ignoreElements()).subscribe(function (y) {
                        return observer.next(y);
                    });
                },
                error: function error(err) {
                    observer.error(err);
                },
                complete: function complete() {
                    observer.complete();
                }
            });
        });
    };
}